#pragma once

#include <stdint.h>
#include <lauxlib.h>

typedef int8_t Area;
typedef uint16_t State;

typedef struct {
    Area area;
    State state;
} Cell;

typedef struct {
    int dim;
    char _[0];
} Array;

#define ARRAYMETA "arraymeta"

#define arraysize(a, i) *((int *) (a->_ + sizeof(int) * (i)))
#define arrayval(a, i) *((Cell *) (a->_ + sizeof(int) * a->dim + sizeof(Cell) * (i)))
#define arrayptr(a, i) ((Cell *) (a->_ + sizeof(int) * a->dim + sizeof(Cell) * (i)))

#define _checkarray(L, i) luaL_checkudata(L, i, ARRAYMETA)
#define checkarray(L) _checkarray(L, 1)
